[kuangbin带你飞]专题一 简单搜索F - Prime Path(POJ 3126)

F - Prime Path
Time Limit:1000MS     Memory Limit:65536KB     64bit IO Format:%I64d & %I64u
Appoint description: 

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
1033 
1733 
3733 
3739 
3779 
8779 
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

题意:求从n到m的变化次数。每次只能变化一位,而且变化后的代码要是素数。

直接bfs

#include
   
   
    
    
#include
    
    
#include
     
     
      
      
#include
      
      
       
       
#include
       
       
         using namespace std; map 
        
          g; bool flag[10000]; void star() { for(int i = 1000; i < 10000; i++) { for(int j = 2; j*j <= i; j++) if(i%j == 0) { g[i] = 1; break; } } } struct node { int x; int step; node(){} node(int xx, int ss) { x = xx; step = ss; } }; queue 
         
           que; void bfs(int n, int m) { while(!que.empty()) que.pop(); que.push(node(n, 0)); int a[4]; memset(flag, 0, sizeof(flag)); while(!que.empty()) { node tmp = que.front(); que.pop(); int t = tmp.x; // printf("%d--%d\n", t, tmp.step); for(int i = 0; i < 4; i++) { a[i] = t%10; t /= 10; } int temp = 1; for(int i = 0; i < 4; i++) { for(int j = 0; j < 10; j++) { if(i == 3 && j == 0) continue; if(j == a[i]) continue; int x = tmp.x - a[i]*temp + j*temp; if(x == m) {printf("%d\n", tmp.step+1);return;} if(!g.count(x) && !flag[x]) { que.push(node(x, tmp.step+1)); flag[x] = 1; } } temp *= 10; } } } int main(void) { int T; star(); scanf("%d", &T); while(T--) { int n, m; scanf("%d%d", &n, &m); if(n == m) { printf("0\n"); continue; } bfs(n, m); } return 0; } 
          
         
       
      
      
     
     
   
   

  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值